Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -1539,21 +10544,118 @@
     # validate header length (124 bytes)
     $buff =~ /^.{8}\0{3}\x7c.{112}\xff\xd8\xff\xdb$/s or return 0;
-    $exifTool->SetFileType();
+    $et->SetFileType();
     SetByteOrder('MM');
-    $exifTool->FoundTag(Make => 'Sony');
-    $exifTool->FoundTag(Model => 'DSC-F1');
+    $et->FoundTag(Make => 'Sony');
+    $et->FoundTag(Model => 'DSC-F1');
     # extract information from 124-byte header
     my $tagTablePtr = GetTagTable('Image::ExifTool::Sony::PMP');
     my %dirInfo = ( DataPt => \$buff, DirName => 'PMP' );
-    $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+    $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
     # process JPEG image
     $raf->Seek(124, 0);
     $$dirInfo{Base} = 124;
-    $exifTool->ProcessJPEG($dirInfo);
+    $et->ProcessJPEG($dirInfo);
     return 1;
 }
 
 #------------------------------------------------------------------------------
-# Decrypt Sony data (ref 1)
+# Set the ARW file type and decide between SubIFD and A100DataOffset
+# Inputs: 0) ExifTool object ref, 1) reference to tag 0x14a raw data
+# Returns: true if tag 0x14a is a SubIFD, false otherwise
+sub SetARW($$)
+{
+    my ($et, $valPt) = @_;
+
+    # assume ARW for now -- SR2's get identified when FileFormat is parsed
+    $et->OverrideFileType($$et{TIFF_TYPE} = 'ARW');
+
+    # this should always be a SubIFD for models other than the A100
+    return 1 unless $$et{Model} eq 'DSLR-A100' and length $$valPt == 4;
+
+    # for the A100, IFD0 tag 0x14a is either a pointer to the raw data if this is
+    # an original image, or a SubIFD offset if the image was edited by Sony IDC,
+    # so assume it points to the raw data if it isn't a valid IFD (this assumption
+    # will be checked later when we try to parse the SR2Private directory)
+    my %subdir = (
+        DirStart => Get32u($valPt, 0),
+        Base     => 0,
+        RAF      => $$et{RAF},
+        AllowOutOfOrderTags => 1, # doh!
+    );
+    return Image::ExifTool::Exif::ValidateIFD(\%subdir);
+}
+
+#------------------------------------------------------------------------------
+# Finish writing ARW image, patching necessary Sony quirks, etc
+# Inputs: 0) ExifTool ref, 1) dirInfo ref, 2) EXIF data ref, 3) image data reference
+# Returns: undef on success, error string otherwise
+# Notes: (it turns that all of this is for the A100 only)
+sub FinishARW($$$$)
+{
+    my ($et, $dirInfo, $dataPt, $imageData) = @_;
+
+    # pre-scan IFD0 to get IFD entry offsets for each tag
+    my $dataLen = length $$dataPt;
+    return 'Truncated IFD0' if $dataLen < 2;
+    my $n = Get16u($dataPt, 0);
+    return 'Truncated IFD0' if $dataLen < 2 + 12 * $n;
+    my ($i, %entry, $dataBlock, $pad, $dataOffset);
+    for ($i=0; $i<$n; ++$i) {
+        my $entry = 2 + $i * 12;
+        $entry{Get16u($dataPt, $entry)} = $entry;
+    }
+    # fix up SR2Private offset and A100DataOffset (A100 only)
+    if ($entry{0xc634} and $$et{MRWDirData}) {
+        return 'Unexpected MRW block' unless $$et{Model} eq 'DSLR-A100';
+        return 'Missing A100DataOffset' unless $entry{0x14a} and $$et{A100DataOffset};
+        # account for total length of image data
+        my $totalLen = 8 + $dataLen;
+        if (ref $imageData) {
+            foreach $dataBlock (@$imageData) {
+                my ($pos, $size, $pad) = @$dataBlock;
+                $totalLen += $size + $pad;
+            }
+        }
+        # align MRW block on an even 4-byte boundary
+        my $remain = $totalLen & 0x03;
+        $pad = 4 - $remain and $totalLen += $pad if $remain;
+        # set offset for the MRW directory data
+        Set32u($totalLen, $dataPt, $entry{0xc634} + 8);
+        # also pad MRWDirData data to an even 4 bytes (just to be safe)
+        $remain = length($$et{MRWDirData}) & 0x03;
+        $$et{MRWDirData} .= "\0" x (4 - $remain) if $remain;
+        $totalLen += length $$et{MRWDirData};
+        # fix up A100DataOffset
+        $dataOffset = $$et{A100DataOffset};
+        Set32u($totalLen, $dataPt, $entry{0x14a} + 8);
+    }
+    # patch double-referenced and incorrectly-sized A100 PreviewImage
+    if ($entry{0x201} and $$et{A100PreviewStart} and
+        $entry{0x202} and $$et{A100PreviewLength})
+    {
+        Set32u($$et{A100PreviewStart}, $dataPt, $entry{0x201} + 8);
+        Set32u($$et{A100PreviewLength}, $dataPt, $entry{0x202} + 8);
+    }
+    # write TIFF IFD structure
+    my $outfile = $$dirInfo{OutFile};
+    my $header = GetByteOrder() . Set16u(0x2a) . Set32u(8);
+    Write($outfile, $header, $$dataPt) or return 'Error writing';
+    # copy over image data
+    if (ref $imageData) {
+        $et->CopyImageData($imageData, $outfile) or return 'Error copying image data';
+    }
+    # write MRW data if necessary
+    if ($$et{MRWDirData}) {
+        Write($outfile, "\0" x $pad) if $pad;   # write padding if necessary
+        Write($outfile, $$et{MRWDirData});
+        delete $$et{MRWDirData};
+        # set TIFF_END to copy over the MRW image data
+        $$et{TIFF_END} = $dataOffset if $dataOffset;
+    }
+    return undef;
+}
+
+#------------------------------------------------------------------------------
+# Decrypt/Encrypt Sony data (ref 1) (reversible encryption)
 # Inputs: 0) data reference, 1) start offset, 2) data length, 3) decryption key
 # Returns: nothing (original data buffer is updated with decrypted data)
@@ -1583,99 +10685,132 @@
 
 #------------------------------------------------------------------------------
-# Set the ARW file type and decide between SubIFD and A100DataOffset
-# Inputs: 0) ExifTool object ref, 1) reference to tag 0x14a raw data
-# Returns: true if tag 0x14a is a SubIFD, false otherwise
-sub SetARW($$)
+# Decipher/encipher Sony tag 0x2010, 0x900b, 0x9050 and 0x940x data (ref PH)
+# Inputs: 0) data reference, 1) true to encipher the data
+sub Decipher($;$)
 {
-    my ($exifTool, $valPt) = @_;
-
-    # assume ARW for now -- SR2's get identified when FileFormat is parsed
-    $exifTool->OverrideFileType($$exifTool{TIFF_TYPE} = 'ARW');
-
-    # this should always be a SubIFD for models other than the A100
-    return 1 unless $$exifTool{Model} eq 'DSLR-A100' and length $$valPt == 4;
-
-    # for the A100, IFD0 tag 0x14a is either a pointer to the raw data if this is
-    # an original image, or a SubIFD offset if the image was edited by Sony IDC,
-    # so assume it points to the raw data if it isn't a valid IFD (this assumption
-    # will be checked later when we try to parse the SR2Private directory)
-    my %subdir = (
-        DirStart => Get32u($valPt, 0),
-        Base     => 0,
-        RAF      => $$exifTool{RAF},
-        AllowOutOfOrderTags => 1, # doh!
+    my ($dataPt, $encipher) = @_;
+    # This is a simple substitution cipher, so use a hardcoded translation table for speed.
+    # The formula is: $c = ($b*$b*$b) % 249, where $c is the enciphered data byte
+    # (note that bytes with values 249-255 are not translated, and 0-1, 82-84,
+    #  165-167 and 248 have the same enciphered value)
+    if ($encipher) {    # encipher
+        $$dataPt =~ tr/\x02-\xf7/\x08\x1b\x40\x7d\xd8\x5e\x0e\xe7\x04V\xea\xcd\x05\x8ap\xb6i\x88\x200\xbe\xd7\x81\xbb\x92\x0c\x28\xecl\xa0\x95Q\xd3\x2f\x5dj\x5c9\x07\xc5\x87L\x1a\xf0\xe2\xef\x24y\x02\xb7\xac\xe0\x60\x2bG\xba\x91\xcbu\x8e\x233\xc4\xe3\x96\xdc\xc2N\x7fb\xf6OeE\xeet\xcf\x138KRST\x5bn\x93\xd02\xb1aAW\xa9D\x27X\xdd\xc3\x10\xbc\xdbs\x83\x181\xd4\x15\xe5_\x7bF\xbf\xf3\xe8\xa4\x2d\x82\xb0\xbd\xaf\x8cZ\x1f\xda\x9fmJ\x3cIw\xccU\x11\x06\x3a\xb3\x7e\x9a\x14\xe4\x25\xc8\xe1v\x86\x1e\x3d\xe96\x1c\xa1\xd2\xb5P\xa2\xb8\x98H\xc7\x29f\x8b\x9e\xa5\xa6\xa7\xae\xc1\xe6\x2a\x85\x0b\xb4\x94\xaa\x03\x97z\xab7\x1dc\x165\xc6\xd6k\x84\x2eh\x3f\xb2\xce\x99\x19MB\xf7\x80\xd5\x0a\x17\x09\xdf\xadr4\xf2\xc0\x9d\x8f\x9c\xca\x26\xa8dY\x8d\x0d\xd1\xedg\x3ex\x22\x3b\xc9\xd9q\x90C\x89o\xf4\x2c\x0f\xa3\xf5\x12\xeb\x9b\x21\x7c\xb9\xde\xf1/;
+    } else {            # decipher
+        $$dataPt =~ tr/\x08\x1b\x40\x7d\xd8\x5e\x0e\xe7\x04V\xea\xcd\x05\x8ap\xb6i\x88\x200\xbe\xd7\x81\xbb\x92\x0c\x28\xecl\xa0\x95Q\xd3\x2f\x5dj\x5c9\x07\xc5\x87L\x1a\xf0\xe2\xef\x24y\x02\xb7\xac\xe0\x60\x2bG\xba\x91\xcbu\x8e\x233\xc4\xe3\x96\xdc\xc2N\x7fb\xf6OeE\xeet\xcf\x138KRST\x5bn\x93\xd02\xb1aAW\xa9D\x27X\xdd\xc3\x10\xbc\xdbs\x83\x181\xd4\x15\xe5_\x7bF\xbf\xf3\xe8\xa4\x2d\x82\xb0\xbd\xaf\x8cZ\x1f\xda\x9fmJ\x3cIw\xccU\x11\x06\x3a\xb3\x7e\x9a\x14\xe4\x25\xc8\xe1v\x86\x1e\x3d\xe96\x1c\xa1\xd2\xb5P\xa2\xb8\x98H\xc7\x29f\x8b\x9e\xa5\xa6\xa7\xae\xc1\xe6\x2a\x85\x0b\xb4\x94\xaa\x03\x97z\xab7\x1dc\x165\xc6\xd6k\x84\x2eh\x3f\xb2\xce\x99\x19MB\xf7\x80\xd5\x0a\x17\x09\xdf\xadr4\xf2\xc0\x9d\x8f\x9c\xca\x26\xa8dY\x8d\x0d\xd1\xedg\x3ex\x22\x3b\xc9\xd9q\x90C\x89o\xf4\x2c\x0f\xa3\xf5\x12\xeb\x9b\x21\x7c\xb9\xde\xf1/\x02-\xf7/;
+    }
+}
+
+#------------------------------------------------------------------------------
+# Process Sony 0x94xx cipherdata directory
+# Inputs: 0) ExifTool object ref, 1) directory information ref, 2) tag table ref
+# Returns: 1 on success
+# Notes:
+# 1) dirInfo may contain VarFormatData (reference to empty list) to return
+#    details about any variable-length-format tags in the table (used when writing)
+# 2) A bug in ExifTool 9.04-9.10 could have double-enciphered these blocks
+sub ProcessEnciphered($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $dirStart = $$dirInfo{DirStart} || 0;
+    my $dirLen = $$dirInfo{DirLen} || (length($$dataPt) - $dirStart);
+    my $data = substr($$dataPt, $dirStart, $dirLen);
+    my %dirInfo = (
+        %$dirInfo,
+        DataPt => \$data,
+        DataPos => $$dirInfo{DataPos} + $dirStart,
+        DirStart => 0,
     );
-    return Image::ExifTool::Exif::ValidateIFD(\%subdir);
+    Decipher(\$data);
+    if ($$et{DoubleCipher}) {
+        Decipher(\$data);
+        $et->WarnOnce('Some Sony metadata is double-enciphered. Write any tag to fix',1);
+    }
+    if ($et->Options('Verbose') > 2) {
+        my $tagInfo = $$dirInfo{TagInfo} || { Name => 'data' };
+        my $str = $$et{DoubleCipher} ? 'ouble-d' : '';
+        $et->VerboseDir("D${str}eciphered $$tagInfo{Name}");
+        $et->VerboseDump(\$data,
+            Prefix  => $$et{INDENT} . '  ',
+            DataPos => $$dirInfo{DirStart} + $$dirInfo{DataPos} + ($$dirInfo{Base} || 0),
+        );
+    }
+    return $et->ProcessBinaryData(\%dirInfo, $tagTablePtr);
 }
 
 #------------------------------------------------------------------------------
-# Finish writing ARW image, patching necessary Sony quirks, etc
-# Inputs: 0) ExifTool ref, 1) dirInfo ref, 2) EXIF data ref, 3) image data reference
-# Returns: undef on success, error string otherwise
-# Notes: (it turns that all of this is for the A100 only)
-sub FinishARW($$$$)
+# Write Sony 0x94xx cipherdata directory
+# Inputs: 0) ExifTool object ref, 1) source dirInfo ref, 2) tag table ref
+# Returns: cipherdata block or undefined on error
+sub WriteEnciphered($$$)
 {
-    my ($exifTool, $dirInfo, $dataPt, $imageData) = @_;
-
-    # pre-scan IFD0 to get IFD entry offsets for each tag
-    my $dataLen = length $$dataPt;
-    return 'Truncated IFD0' if $dataLen < 2;
-    my $n = Get16u($dataPt, 0);
-    return 'Truncated IFD0' if $dataLen < 2 + 12 * $n;
-    my ($i, %entry, $dataBlock, $pad, $dataOffset);
-    for ($i=0; $i<$n; ++$i) {
-        my $entry = 2 + $i * 12;
-        $entry{Get16u($dataPt, $entry)} = $entry;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;
+    my $dataPt = $$dirInfo{DataPt};
+    my $dirStart = $$dirInfo{DirStart} || 0;
+    my $dirLen = $$dirInfo{DirLen} || (length($$dataPt) - $dirStart);
+    my $data = substr($$dataPt, $dirStart, $dirLen);
+    my $changed = $$et{CHANGED};
+    Decipher(\$data);
+    # fix double-enciphered data (due to bug in ExifTool 9.04-9.10)
+    if ($$et{DoubleCipher}) {
+        Decipher(\$data);
+        ++$$et{CHANGED};
+        $et->WarnOnce('Fixed double-enciphered Sony metadata',1);
     }
-    # fix up SR2Private offset and A100DataOffset (A100 only)
-    if ($entry{0xc634} and $$exifTool{MRWDirData}) {
-        return 'Unexpected MRW block' unless $$exifTool{Model} eq 'DSLR-A100';
-        return 'Missing A100DataOffset' unless $entry{0x14a} and $$exifTool{A100DataOffset};
-        # account for total length of image data
-        my $totalLen = 8 + $dataLen;
-        if (ref $imageData) {
-            foreach $dataBlock (@$imageData) {
-                my ($pos, $size, $pad) = @$dataBlock;
-                $totalLen += $size + $pad;
-            }
+    my %dirInfo = (
+        %$dirInfo,
+        DataPt => \$data,
+        DataPos => $$dirInfo{DataPos} + $dirStart,
+        DirStart => 0,
+    );
+    $data = $et->WriteBinaryData(\%dirInfo, $tagTablePtr);
+    if ($changed == $$et{CHANGED}) {
+        # nothing changed, so recover original data
+        $data = substr($$dataPt, $dirStart, $dirLen);
+    } elsif (defined $data) {
+        Decipher(\$data,1);     # re-encipher
+    }
+    return $data;
+}
+
+#------------------------------------------------------------------------------
+# Process "rtmd" timed metadata embedded in Sony MP4 videos (ref PH)
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+sub Process_rtmd($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $dataPos = ($$dirInfo{DataPos} || 0) + ($$dirInfo{Base} || 0);
+    my $end = length $$dataPt;
+    return 0 if $end < 2;
+    $et->VerboseDir('Sony rtmd', undef, $end);
+    # Note:  The 0x1c-byte header contains some as-yet unextracted information:
+    #  offset 0x0e: int8u some minutes
+    #         0x0f: int8u some seconds
+    #         0x11: int8u frame number? (0-24 or 0-25)
+    my $pos = Get16u($dataPt, 0);   # get header length (= 0x1c)
+    while ($pos + 4 < $end) {
+        my $tag = Get16u($dataPt, $pos);
+        last if $tag == 0;
+        my $len = Get16u($dataPt, $pos+2);
+        if ($tag == 0x060e) {
+            $len = 0x10;    # (unknown 16 bytes starting with 0x060e2b340253)
+        } else {
+            $pos += 4;      # skip tag id/size
+            next if $tag == 0x8300; # descend into contents of 0x8300 (container)
         }
-        # align MRW block on an even 4-byte boundary
-        my $remain = $totalLen & 0x03;
-        $pad = 4 - $remain and $totalLen += $pad if $remain;
-        # set offset for the MRW directory data
-        Set32u($totalLen, $dataPt, $entry{0xc634} + 8);
-        # also pad MRWDirData data to an even 4 bytes (just to be safe)
-        $remain = length($$exifTool{MRWDirData}) & 0x03;
-        $$exifTool{MRWDirData} .= "\0" x (4 - $remain) if $remain;
-        $totalLen += length $$exifTool{MRWDirData};
-        # fix up A100DataOffset
-        $dataOffset = $$exifTool{A100DataOffset};
-        Set32u($totalLen, $dataPt, $entry{0x14a} + 8);
+        last if $pos + $len > $end;
+        $et->HandleTag($tagTablePtr, $tag, undef,
+            DataPt  => $dataPt,
+            DataPos => $dataPos,
+            Start   => $pos,
+            Size    => $len,
+        );
+        $pos += $len;       # step to next tag
     }
-    # patch double-referenced and incorrectly-sized A100 PreviewImage
-    if ($entry{0x201} and $$exifTool{A100PreviewStart} and
-        $entry{0x202} and $$exifTool{A100PreviewLength})
-    {
-        Set32u($$exifTool{A100PreviewStart}, $dataPt, $entry{0x201} + 8);
-        Set32u($$exifTool{A100PreviewLength}, $dataPt, $entry{0x202} + 8);
-    }
-    # write TIFF IFD structure
-    my $outfile = $$dirInfo{OutFile};
-    my $header = GetByteOrder() . Set16u(0x2a) . Set32u(8);
-    Write($outfile, $header, $$dataPt) or return 'Error writing';
-    # copy over image data
-    if (ref $imageData) {
-        $exifTool->CopyImageData($imageData, $outfile) or return 'Error copying image data';
-    }
-    # write MRW data if necessary
-    if ($$exifTool{MRWDirData}) {
-        Write($outfile, "\0" x $pad) if $pad;   # write padding if necessary
-        Write($outfile, $$exifTool{MRWDirData});
-        delete $$exifTool{MRWDirData};
-        # set TIFF_END to copy over the MRW image data
-        $$exifTool{TIFF_END} = $dataOffset if $dataOffset;
-    }
-    return undef;
-}
+    return 1;
+};
 
 #------------------------------------------------------------------------------
@@ -1685,8 +10820,8 @@
 sub ProcessSRF($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $start = $$dirInfo{DirStart};
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
 
     # process IFD chain
@@ -1701,7 +10836,7 @@
         }
         my $srf = $$dirInfo{DirName} = "SRF$ifd";
-        $exifTool->{SET_GROUP1} = $srf;
-        $success = Image::ExifTool::Exif::ProcessExif($exifTool, $dirInfo, $tagTablePtr);
-        delete $exifTool->{SET_GROUP1};
+        $$et{SET_GROUP1} = $srf;
+        $success = Image::ExifTool::Exif::ProcessExif($et, $dirInfo, $tagTablePtr);
+        delete $$et{SET_GROUP1};
         last unless $success;
 #
@@ -1723,10 +10858,12 @@
             # get the key to decrypt IFD1
             my $cp = $start + 0x8ddc;    # why?
+            last if $cp + 1 > length($$dataPt);
             my $ip = $cp + 4 * unpack("x$cp C", $$dataPt);
+            last if $ip + 4 > length($$dataPt);
             $key = unpack("x$ip N", $$dataPt);
             $len = $cp + $nextIFD;  # decrypt up to $cp
         } elsif ($ifd == 2) {
             # get the key to decrypt IFD2
-            $key = $exifTool->{SRF2Key};
+            $key = $$et{SRF2Key};
             $len = length($$dataPt) - $nextIFD; # decrypt rest of maker notes
         } else {
@@ -1737,7 +10874,7 @@
         next unless $verbose > 2;
         # display decrypted data in verbose mode
-        $exifTool->VerboseDir("Decrypted SRF$ifd", 0, $nextIFD + $len);
-        $exifTool->VerboseDump($dataPt,
-            Prefix => "$exifTool->{INDENT}  ",
+        $et->VerboseDir("Decrypted SRF$ifd", 0, $nextIFD + $len);
+        $et->VerboseDump($dataPt,
+            Prefix => "$$et{INDENT}  ",
             Start => $nextIFD,
             DataPos => $$dirInfo{DataPos},
@@ -1752,9 +10889,9 @@
 sub WriteSR2($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;      # allow dummy access
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;      # allow dummy access
     my $buff = '';
     $$dirInfo{OutFile} = \$buff;
-    return ProcessSR2($exifTool, $dirInfo, $tagTablePtr);
+    return ProcessSR2($et, $dirInfo, $tagTablePtr);
 }
 
@@ -1765,5 +10902,5 @@
 sub ProcessSR2($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $raf = $$dirInfo{RAF};
     my $dataPt = $$dirInfo{DataPt};
@@ -1774,7 +10911,7 @@
 
     # clear SR2 member variables to be safe
-    delete $$exifTool{SR2SubIFDOffset};
-    delete $$exifTool{SR2SubIFDLength};
-    delete $$exifTool{SR2SubIFDKey};
+    delete $$et{SR2SubIFDOffset};
+    delete $$et{SR2SubIFDLength};
+    delete $$et{SR2SubIFDKey};
 
     # make sure we have the first 4 bytes available to test directory type
@@ -1793,8 +10930,8 @@
     if ($dataPt and $$dataPt =~ /^\0MR[IM]/) {
         my ($err, $srfPos, $srfLen, $dataOffset);
-        $dataOffset = $$exifTool{A100DataOffset};
+        $dataOffset = $$et{A100DataOffset};
         if ($dataOffset) {
             # save information about the RAW data trailer so it will be preserved
-            $$exifTool{KnownTrailer} = { Name => 'A100 RAW Data', Start => $dataOffset };
+            $$et{KnownTrailer} = { Name => 'A100 RAW Data', Start => $dataOffset };
         } else {
             $err = 'A100DataOffset tag is missing from A100 ARW image';
@@ -1809,6 +10946,6 @@
         }
         if ($err) {
-            $outfile and $exifTool->Error($err), return undef;
-            $exifTool->Warn($err);
+            $outfile and $et->Error($err), return undef;
+            $et->Warn($err);
             return 0;
         }
@@ -1817,34 +10954,34 @@
         if ($outfile) {
             # save MRW data to be written last
-            $$exifTool{MRWDirData} = Image::ExifTool::MinoltaRaw::WriteMRW($exifTool, \%dirInfo);
-            return $$exifTool{MRWDirData} ? "\0\0\0\0\0\0" : undef;
+            $$et{MRWDirData} = Image::ExifTool::MinoltaRaw::WriteMRW($et, \%dirInfo);
+            return $$et{MRWDirData} ? "\0\0\0\0\0\0" : undef;
         } else {
-            if (not $outfile and $$exifTool{HTML_DUMP}) {
-                $exifTool->HDump($srfPos, $srfLen, '[A100 SRF Data]');
+            if (not $outfile and $$et{HTML_DUMP}) {
+                $et->HDump($srfPos, $srfLen, '[A100 SRF Data]');
             }
-            return Image::ExifTool::MinoltaRaw::ProcessMRW($exifTool, \%dirInfo);
+            return Image::ExifTool::MinoltaRaw::ProcessMRW($et, \%dirInfo);
         }
-    } elsif ($$exifTool{A100DataOffset}) {
+    } elsif ($$et{A100DataOffset}) {
         my $err = 'Unexpected A100DataOffset tag';
-        $outfile and $exifTool->Error($err), return undef;
-        $exifTool->Warn($err);
+        $outfile and $et->Error($err), return undef;
+        $et->Warn($err);
         return 0;
     }
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
     my $result;
     if ($outfile) {
-        $result = Image::ExifTool::Exif::WriteExif($exifTool, $dirInfo, $tagTablePtr);
+        $result = Image::ExifTool::Exif::WriteExif($et, $dirInfo, $tagTablePtr);
         return undef unless $result;
         $$outfile .= $result;
 
     } else {
-        $result = Image::ExifTool::Exif::ProcessExif($exifTool, $dirInfo, $tagTablePtr);
+        $result = Image::ExifTool::Exif::ProcessExif($et, $dirInfo, $tagTablePtr);
     }
-    return $result unless $result and $$exifTool{SR2SubIFDOffset};
+    return $result unless $result and $$et{SR2SubIFDOffset};
     # only take first offset value if more than one!
-    my @offsets = split ' ', $exifTool->{SR2SubIFDOffset};
+    my @offsets = split ' ', $$et{SR2SubIFDOffset};
     my $offset = shift @offsets;
-    my $length = $exifTool->{SR2SubIFDLength};
-    my $key = $exifTool->{SR2SubIFDKey};
+    my $length = $$et{SR2SubIFDLength};
+    my $key = $$et{SR2SubIFDKey};
     my @subifdPos;
     if ($offset and $length and defined $key) {
@@ -1860,6 +10997,6 @@
             # display decrypted data in verbose mode
             if ($verbose > 2 and not $outfile) {
-                $exifTool->VerboseDir("Decrypted SR2SubIFD", 0, $length);
-                $exifTool->VerboseDump(\$buff, Addr => $offset + $base);
+                $et->VerboseDir("Decrypted SR2SubIFD", 0, $length);
+                $et->VerboseDump(\$buff, Addr => $offset + $base);
             }
             my $num = '';
@@ -1878,5 +11015,5 @@
                     my $fixup = new Image::ExifTool::Fixup;
                     $dirInfo{Fixup} = $fixup;
-                    $result = $exifTool->WriteDirectory(\%dirInfo, $subTable);
+                    $result = $et->WriteDirectory(\%dirInfo, $subTable);
                     return undef unless $result;
                     # save position of this SubIFD
@@ -1885,7 +11022,7 @@
                     $$fixup{Start} += length($$outfile);
                     $$outfile .= $result;
-                    $dirInfo->{Fixup}->AddFixup($fixup);
+                    $$dirInfo{Fixup}->AddFixup($fixup);
                 } else {
-                    $result = $exifTool->ProcessDirectory(\%dirInfo, $subTable);
+                    $result = $et->ProcessDirectory(\%dirInfo, $subTable);
                 }
                 last unless @offsets;
@@ -1895,5 +11032,5 @@
 
         } else {
-            $exifTool->Warn('Error reading SR2 data');
+            $et->Warn('Error reading SR2 data');
         }
     }
@@ -1907,7 +11044,7 @@
         }
         # save the new SR2SubIFD Length and Key to be used later for encryption
-        $$exifTool{SR2SubIFDLength} = $sr2Len;
-        my $newKey = $$exifTool{VALUE}{SR2SubIFDKey};
-        $$exifTool{SR2SubIFDKey} = $newKey if defined $newKey;
+        $$et{SR2SubIFDLength} = $sr2Len;
+        my $newKey = $$et{VALUE}{SR2SubIFDKey};
+        $$et{SR2SubIFDKey} = $newKey if defined $newKey;
         # update SubIFD pointers manually and add to fixup, and set SR2SubIFDLength
         my $n = Get16u($outfile, 0);
@@ -1921,5 +11058,5 @@
             my $fmt = Get16u($outfile, $entry + 2);
             if ($fmt != 0x04) { # must be int32u
-                $exifTool->Error("Unexpected format ($fmt) for SR2SubIFD tag");
+                $et->Error("Unexpected format ($fmt) for SR2SubIFD tag");
                 return undef;
             }
@@ -1933,5 +11070,5 @@
             foreach $pos (@subifdPos) {
                 Set32u($pos, $outfile, $valuePtr);
-                $dirInfo->{Fixup}->AddFixup($valuePtr, $tag);
+                $$dirInfo{Fixup}->AddFixup($valuePtr, $tag);
                 undef $tag;
                 $valuePtr += 4;
@@ -1939,5 +11076,5 @@
         }
         unless ($found{0x7200} and $found{0x7201}) {
-            $exifTool->Error('Missing SR2SubIFD tag');
+            $et->Error('Missing SR2SubIFD tag');
             return undef;
         }
@@ -1970,5 +11107,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -1985,4 +11122,6 @@
 =item L<http://www.klingebiel.com/tempest/hd/pmp.html>
 
+=item (...plus lots of testing with my RX100!)
+
 =back
 
@@ -1990,6 +11129,6 @@
 
 Thanks to Thomas Bodenmann, Philippe Devaux, Jens Duttke, Marcus
-Holland-Moritz, Andrey Tverdokhleb, Rudiger Lange, Igal Milchtaich and
-Michael Reitinger for help decoding some tags.
+Holland-Moritz, Andrey Tverdokhleb, Rudiger Lange, Igal Milchtaich, Michael
+Reitinger and Jos Roost for help decoding some tags.
 
 =head1 SEE ALSO
